﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows.Media;
using XamDataGrid_CellBinding_CS.Model;

namespace XamDataGrid_CellBinding_CS.Infrastructure
{
    public class NotificationObject : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            var property = this.GetType().GetProperty(propertyName);
            if (property.Name == "IsCompleted")
            {
                // IsCompleted の値に応じて ForegroundColor の値を更新
                TaskItem item = this as TaskItem;
                if (item != null)
                {
                    bool isCompleted = (bool)property.GetValue(this);
                    item.ForegroundColor = (isCompleted == true) ? Brushes.Black : Brushes.Red;
                }
            }
            this.PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
