﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Input;
using System.Windows.Media;
using XamDataGrid_CellBinding_CS.Commands;
using XamDataGrid_CellBinding_CS.Model;

namespace XamDataGrid_CellBinding_CS.ViewModel
{
    class MainViewModel
    {
        public List<TaskItem> Tasks { get; set; }

        private ICommand _completeAllCommand;
        public ICommand CompleteAllCommand
        {
            get
            {
                if (_completeAllCommand == null)
                {
                    _completeAllCommand = new DelegateCommand
                    {
                        ExecuteHandler = (param) =>
                        {
                            List<TaskItem> tasks = param as List<TaskItem>;
                            // 全てのタスクを完了（true）に更新する
                            tasks.ForEach(t => t.IsCompleted = true);
                        },
                        CanExecuteHandler = (param) =>
                        {
                            return true;
                        }
                    };
                }
                return _completeAllCommand;
            }
        }

        public MainViewModel()
        {
            #region タスク作成
            List<TaskItem> tasks = new List<TaskItem>();

            for (int i = 0; i < 200; i++)
            {
                TaskItem task = new TaskItem();
                task.ID = i;
                task.Title = "タイトル" + i.ToString();
                task.Due = DateTime.Today.AddDays(i);
                task.IsCompleted = (i % 3 == 0) ? true : false;

                // スタイルの設定（タスクが完了していなければ、前景色 Redとします。）
                task.ForegroundColor = (task.IsCompleted == true) ? Brushes.Black : Brushes.Red;

                tasks.Add(task);
            }

            this.Tasks = tasks;
            #endregion
        }

    }
}
